using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.IO;

using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Runtime.Serialization;


namespace dockwindow_position
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.Panel panel3 = new Panel();

		private List<System.Windows.Forms.Panel> lstPnls = new List<Panel>();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            //Syncfusion.Windows.Forms.Tools.XPMenus.BarItem oMenu = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            //oMenu.Text = "test";
            mainMenu1.MenuItems.Add("NewDockPnls", XXHandler);
			mainMenu1.MenuItems.Add("NewTabPnls", XXHandlerTab);
            System.Windows.Forms.MenuItem oLayout = new System.Windows.Forms.MenuItem();
            System.Windows.Forms.MenuItem oLayout1 = new System.Windows.Forms.MenuItem();
            System.Windows.Forms.MenuItem oLayout2 = new System.Windows.Forms.MenuItem();
			System.Windows.Forms.MenuItem oLayout3 = new System.Windows.Forms.MenuItem();

            oLayout.Text = "Layout";
            oLayout1.Text = "Save";
            oLayout1.Click += new EventHandler(LayoutSave_Click);
            oLayout2.Text = "Load";
            oLayout2.Click += new EventHandler(LayoutLoad_Click);
			oLayout3.Text = "Load2";
			oLayout3.Click += new EventHandler(LayoutLoad2_Click);
            oLayout.MenuItems.Add(oLayout1);
            oLayout.MenuItems.Add(oLayout2);
			oLayout.MenuItems.Add(oLayout3);
            System.Windows.Forms.MenuItem x = mainMenu1.MenuItems["Layout"];
            mainMenu1.MenuItems.Add(oLayout);            

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
        AppStateSerializer serializer = new AppStateSerializer(SerializeMode.XMLFile, "myfile");
        void LayoutLoad_Click(object sender, EventArgs e)
        {           
            this.dockingManager1.LoadDockState(serializer);       
        }

		void LayoutLoad2_Click(object sender, EventArgs e)
		{
            this.dockingManager1.LoadDockState(serializer);           
		}

        void LayoutSave_Click(object sender, EventArgs e)
        {         
            this.dockingManager1.SaveDockState(serializer);
            serializer.PersistNow();           		
        }

		//get control the control for the given configuration
		private Control GetParent(ControlConfiguration oConfig)
		{			
			if (oConfig.RelatedControl == "panel1")
				return panel1;
			else if (oConfig.RelatedControl == "panel2")
				return panel2;
			else if (oConfig.RelatedControl == "panel3")
				return panel3;
			else
			{
				//docking to a dynamic panel, get it
				foreach (Control pnl in lstPnls)
				{
					if (pnl.Name == oConfig.RelatedControl)
						return pnl;
				}

				//not found, have to create the panel to which this one will be docked
				Panel oNewPnl = GetPanel();
				lstPnls.Add(oNewPnl);
				return oNewPnl;
			}
		}

		//get a new panel
		private System.Windows.Forms.Panel GetPanel()
		{
			System.Windows.Forms.Panel pnl = new Panel();

			int nPs = 4 + lstPnls.Count;
			//this.dockingManager1.SetEnableDocking(pnl, true);
			pnl.Location = new System.Drawing.Point(1, 21);
			pnl.Name = "panel" + nPs.ToString();
			pnl.Size = new System.Drawing.Size(130, 264);
			pnl.TabIndex = nPs;
			lstPnls.Add(pnl);

			return pnl;
		}

		//get a new panel with a given name
		private System.Windows.Forms.Panel GetPanel(string strName)
		{
			if (strName == "panel1")
				return panel1;
			else if (strName == "panel2")
				return panel2;
			else if (strName == "panel3")
				return panel3;
			else
			{
				foreach (Panel pnl in lstPnls)
				{
					if (pnl.Name == strName)
						return pnl;
				}
			}
			System.Windows.Forms.Panel Newpnl = new Panel();
			int nPs = 4 + lstPnls.Count;
			//this.dockingManager1.SetEnableDocking(pnl, true);
			Newpnl.Name = strName;
			Newpnl.TabIndex = nPs;
			lstPnls.Add(Newpnl);

			return Newpnl;
		}

		//add docked panel
		private void XXHandler(object sender, EventArgs e)
		{
			System.Windows.Forms.Panel pnl = GetPanel();
			
			dockingManager1.DockControl(pnl, this, Syncfusion.Windows.Forms.Tools.DockingStyle.Bottom, 200);			
			dockingManager1.SetDockLabel(pnl, pnl.Name);
		}  

		//add tabbed panel to first visible dynamic panel
        private void XXHandlerTab(object sender, EventArgs e)
        {
			Control oC = null;

			//get visible dynamic panel
			for (int i = 0; i < lstPnls.Count; ++i)
			{
				if (true == lstPnls[i].Visible)
				{
					oC = lstPnls[i];
					break;
				}
			}
			if (null == oC)
				return;

			//get new panel
			System.Windows.Forms.Panel pnl = GetPanel();

			//add new panel as tabbed one to visible panel
			dockingManager1.DockControl(pnl, oC, Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed, 0, false);
			dockingManager1.SetDockLabel(pnl, pnl.Name);
			
			lstPnls.Add(pnl);
        }        

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.dockingManager1 = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).BeginInit();
			// 
			// panel1
			// 
			this.dockingManager1.SetEnableDocking(this.panel1, true);
			this.panel1.Location = new System.Drawing.Point(1, 21);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(130, 264);
			this.panel1.TabIndex = 0;
			// 
			// panel2
			// 
			this.dockingManager1.SetEnableDocking(this.panel2, true);
			this.panel2.Location = new System.Drawing.Point(1, 21);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(150, 264);
			this.panel2.TabIndex = 1;
			// 
			// dockingManager1
			// 
			this.dockingManager1.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager1.DockLayoutStream")));
			this.dockingManager1.HostControl = this;
			this.dockingManager1.NewDockStateEndLoad += new System.EventHandler(this.dockingManager1_NewDockStateEndLoad);
			this.dockingManager1.SetDockLabel(this.panel1, "panel1");
			this.dockingManager1.SetDockLabel(this.panel2, "panel2");
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4});
			this.menuItem1.Text = "Position Info";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Panel1";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Panel2";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "Panel3";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 286);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).EndInit();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			this.GetPositionInfo(this.panel1);
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			this.GetPositionInfo(this.panel2);		
		}

		private void GetPositionInfo (Panel panel)
		{	
			int left, right, top, bottom;

			Syncfusion.Windows.Forms.Tools.DockHost dhost = panel.Parent as Syncfusion.Windows.Forms.Tools.DockHost; 
			Syncfusion.Windows.Forms.Tools.DockHostController dhc = dhost.InternalController as Syncfusion.Windows.Forms.Tools.DockHostController; 
			Syncfusion.Windows.Forms.Tools.DockInfo di = dhc.DICurrent;
			
			left = di.rcDockArea.Left;
			top = di.rcDockArea.Top;
			bottom = di.rcDockArea.Bottom;
			right = di.rcDockArea.Right;

			string dockStyle = di.dStyle.ToString();

			MessageBox.Show("DockingStyle : " + dockStyle + "\n" + "Bounds : " + di.rcDockArea.ToString());
		}

		private void dockingManager1_NewDockStateEndLoad(object sender, System.EventArgs e)
		{
            // To find whether particular control is Docking window
            if (!this.dockingManager1.GetEnableDocking(this.panel3))
            {
                panel3.Name = "panel3";
                //dockingManager1.DockControl(panel3, this, Syncfusion.Windows.Forms.Tools.DockingStyle.Bottom, 200);
                dockingManager1.DockControl(panel3, panel2, Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed, 0, true);
                dockingManager1.SetDockLabel(panel3, "panel3");
            }
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			this.GetPositionInfo(this.panel3);
		}
	}

	public class ControlConfiguration
	{
		public bool Visibility { get; set; }
		public bool Enabled { get; set; }
		public string Name { get; set; }
		public string RelatedControl { get; set; }
		public int Left { get; set; }
		public int Top { get; set; }
		public int Width { get; set; }
		public int Height { get; set; }
		public int TabGroup { get; set; }
		public int TabIndex { get; set; }
		public int DockStyle { get; set; }
		public int DockPreference { get; set; }
		public int ControlIdx {get;set;}
		
		public int Size { get; set; }

		public ControlConfiguration()
		{
		}
	}

	public class SortByTabGrp : IComparer<ControlConfiguration>
	{
		public int Compare(ControlConfiguration a, ControlConfiguration b)
		{
			if (a.TabGroup == b.TabGroup)
				return a.TabIndex.CompareTo(b.TabIndex);
			else
				return a.TabGroup.CompareTo(b.TabGroup);
		}
	}

	public class SortByIdx : IComparer<ControlConfiguration>
	{
		public int Compare(ControlConfiguration a, ControlConfiguration b)
		{
			return a.ControlIdx.CompareTo(b.ControlIdx);
			
		}
	}

	public class SortByX : IComparer<ControlConfiguration>
	{
		public int Compare(ControlConfiguration a, ControlConfiguration b)
		{
			if (0 == a.DockStyle.CompareTo(b.DockStyle))
			{
				return a.ControlIdx.CompareTo(b.ControlIdx);
			}
			else
			{
				return a.DockStyle.CompareTo(b.DockStyle);
			}

		}
	}

	public class SortByX1 : IComparer<ControlConfiguration>
	{
		public int Compare(ControlConfiguration a, ControlConfiguration b)
		{
			if (0 == a.DockStyle.CompareTo(b.DockStyle))
			{
				if (0 == a.TabGroup.CompareTo(b.TabGroup))
				{
					return a.TabIndex.CompareTo(b.TabIndex);
				}
				return a.TabGroup.CompareTo(b.TabGroup);
			}
			else
			{
				return a.DockStyle.CompareTo(b.DockStyle);
			}
		}
	}

	public class ControlConfigCollection
	{
		public List<ControlConfiguration> m_lstConfigs = new List<ControlConfiguration>();
		public ControlConfigCollection()
		{
		}

		public void Add(ControlConfiguration oConfig)
		{
			m_lstConfigs.Add(oConfig);
		}

		public void Save()
		{
			XmlSerializer oSerializer = new XmlSerializer(typeof(ControlConfigCollection));
			StringWriter textWriter = new StringWriter();
            StreamWriter oSW = new StreamWriter("..\\..\\..\\..\\..\\result.xml", false, System.Text.Encoding.Unicode);

			oSerializer.Serialize(textWriter, this);

			oSW.Write(textWriter.ToString());
			oSW.Close();
		}

		public void Load()
		{
			XmlSerializer oSerializer = new XmlSerializer(typeof(ControlConfigCollection));
            StreamReader oSR = new StreamReader("..\\..\\..\\..\\..\\result.xml", true);

			ControlConfigCollection oColl = (ControlConfigCollection) oSerializer.Deserialize(oSR);
			oSR.Close();

			m_lstConfigs = oColl.m_lstConfigs;
		}
	}
}
